


<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN"
  "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html id="htmlId">
<head>
  <title>Coverage Report :: Main</title>
  <style type="text/css">
    @import "../../.css/coverage.css";
  </style>
</head>

<body>
<div class="header"></div>

<div class="content">
<div class="breadCrumbs">
    [ <a href="../../index.html">all classes</a> ]
    [ <a href="../index.html">com.dema.timeregistration.application</a> ]
</div>

<h1>Coverage Summary for Class: Main (com.dema.timeregistration.application)</h1>

<table class="coverageStats">
<tr>
  <th class="name">Class</th>
<th class="coverageStat 
">
  Class, %
</th>
<th class="coverageStat 
">
  Method, %
</th>
<th class="coverageStat 
">
  Line, %
</th>
</tr>
<tr>
  <td class="name">Main</td>
<td class="coverageStat">
  <span class="percent">
    0%
  </span>
  <span class="absValue">
    (0/ 1)
  </span>
</td>
<td class="coverageStat">
  <span class="percent">
    0%
  </span>
  <span class="absValue">
    (0/ 2)
  </span>
</td>
<td class="coverageStat">
  <span class="percent">
    0%
  </span>
  <span class="absValue">
    (0/ 38)
  </span>
</td>
</tr>

</table>

<br/>
<br/>


<div class="sourceCode"><i>1</i>&nbsp;package com.dema.timeregistration.application;
<i>2</i>&nbsp;
<i>3</i>&nbsp;import com.dema.timeregistration.Utils;
<i>4</i>&nbsp;import com.dema.timeregistration.application.command.*;
<i>5</i>&nbsp;import com.dema.timeregistration.entity.GlobalRole;
<i>6</i>&nbsp;import com.dema.timeregistration.entity.User;
<i>7</i>&nbsp;import com.dema.timeregistration.repository.*;
<i>8</i>&nbsp;import com.dema.timeregistration.repository.jpa.JpaRepositoryConfiguration;
<i>9</i>&nbsp;import com.dema.timeregistration.service.*;
<i>10</i>&nbsp;
<i>11</i>&nbsp;import javax.persistence.EntityManager;
<i>12</i>&nbsp;import javax.persistence.Persistence;
<i>13</i>&nbsp;import java.io.IOException;
<i>14</i>&nbsp;import java.nio.file.Files;
<i>15</i>&nbsp;import java.nio.file.Path;
<i>16</i>&nbsp;import java.nio.file.Paths;
<i>17</i>&nbsp;import java.util.Scanner;
<i>18</i>&nbsp;import java.util.Set;
<i>19</i>&nbsp;
<b class="nc"><i>20</i>&nbsp;public class Main {</b>
<i>21</i>&nbsp;    public static void main(String[] args) throws IOException {
<b class="nc"><i>22</i>&nbsp;        Path dbFolder = Paths.get(&quot;./db&quot;);</b>
<i>23</i>&nbsp;
<b class="nc"><i>24</i>&nbsp;        if (!Files.exists(dbFolder)) {</b>
<b class="nc"><i>25</i>&nbsp;            Files.createDirectory(dbFolder);</b>
<b class="nc"><i>26</i>&nbsp;            System.out.println(&quot;Created Directory &quot; + dbFolder.toAbsolutePath().toString());</b>
<i>27</i>&nbsp;        }
<i>28</i>&nbsp;
<b class="nc"><i>29</i>&nbsp;        ApplicationContext applicationContext = new ApplicationContext();</b>
<i>30</i>&nbsp;
<i>31</i>&nbsp;        // Instantiate Dependencies
<b class="nc"><i>32</i>&nbsp;        EntityManager entityManager = Persistence.createEntityManagerFactory(&quot;timeregistration&quot;, JpaRepositoryConfiguration.properties).createEntityManager();</b>
<i>33</i>&nbsp;
<b class="nc"><i>34</i>&nbsp;        UserRepository userRepository = new JpaUserRepository(entityManager);</b>
<b class="nc"><i>35</i>&nbsp;        CompanyRepository companyRepository = new JpaCompanyRepository(entityManager);</b>
<b class="nc"><i>36</i>&nbsp;        TaskRepository taskRepository = new JpaTaskRepository(entityManager);</b>
<b class="nc"><i>37</i>&nbsp;        ProjectRepository projectRepository = new JpaProjectRepository(entityManager);</b>
<i>38</i>&nbsp;
<b class="nc"><i>39</i>&nbsp;        UserAccessService userAccessService = new UserAccessService(userRepository);</b>
<b class="nc"><i>40</i>&nbsp;        AdministratorService administratorService = new AdministratorService(userRepository, companyRepository, userAccessService);</b>
<b class="nc"><i>41</i>&nbsp;        UserService userService = new UserService(userRepository);</b>
<b class="nc"><i>42</i>&nbsp;        ProjectService projectService = new ProjectService(userRepository, companyRepository, projectRepository, userAccessService);</b>
<b class="nc"><i>43</i>&nbsp;        TaskService taskService = new TaskService(taskRepository, projectRepository, companyRepository, userAccessService);</b>
<b class="nc"><i>44</i>&nbsp;        TimeEntryService timeEntryService = new TimeEntryService(userRepository, taskRepository);</b>
<b class="nc"><i>45</i>&nbsp;        GenerateReportService generateReportService = new GenerateReportService(projectRepository);</b>
<b class="nc"><i>46</i>&nbsp;        UserBookingService userBookingService = new UserBookingService(userRepository, projectRepository, userAccessService);</b>
<i>47</i>&nbsp;
<i>48</i>&nbsp;        // Initial Data
<b class="nc"><i>49</i>&nbsp;        if (!userRepository.findByEmail(&quot;admin@app&quot;).isPresent()) {</b>
<b class="nc"><i>50</i>&nbsp;            User admin = User.create(&quot;admin@app&quot;, &quot;Administrator&quot;, GlobalRole.GLOBAL_ADMINISTRATOR);</b>
<b class="nc"><i>51</i>&nbsp;            userRepository.save(admin);</b>
<i>52</i>&nbsp;        }
<i>53</i>&nbsp;
<i>54</i>&nbsp;        // The DocumentationCommand needs a reference to the CommandInterpreter and is therefore populated with it
<i>55</i>&nbsp;        // after instantiation
<b class="nc"><i>56</i>&nbsp;        DocumentationCommand documentationCommand = new DocumentationCommand();</b>
<i>57</i>&nbsp;
<i>58</i>&nbsp;        // Register commands that will be interpreted by the CommandInterpreter
<b class="nc"><i>59</i>&nbsp;        Set&lt;Command&gt; commands = Utils.newHashSet(</b>
<i>60</i>&nbsp;                new LoginCommand(userService, applicationContext),
<i>61</i>&nbsp;                new RegisterCommand(userService),
<i>62</i>&nbsp;
<i>63</i>&nbsp;                new ListUsersCommand(userService),
<i>64</i>&nbsp;                new ListCompaniesCommand(administratorService),
<i>65</i>&nbsp;                new ListProjectsCommand(projectService, administratorService),
<i>66</i>&nbsp;                new ListTasksCommand(taskService, projectService),
<i>67</i>&nbsp;                new ListTimeEntriesCommand(timeEntryService, applicationContext),
<i>68</i>&nbsp;                new ListUserBookingsCommand(userBookingService, userService),
<i>69</i>&nbsp;
<i>70</i>&nbsp;                new CreateProjectCommand(administratorService, userService, projectService, applicationContext),
<i>71</i>&nbsp;                new UpdateProjectCommand(projectService, applicationContext),
<i>72</i>&nbsp;                new GenerateReportCommand(taskService, projectService, applicationContext, generateReportService),
<i>73</i>&nbsp;
<i>74</i>&nbsp;                new CreateTaskCommand(taskService, projectService, applicationContext),
<i>75</i>&nbsp;                new UpdateTaskCommand(taskService, applicationContext),
<i>76</i>&nbsp;
<i>77</i>&nbsp;                new RegisterTimeEntryCommand(timeEntryService, taskService, applicationContext),
<i>78</i>&nbsp;                new UpdateTimeEntryCommand(timeEntryService, taskService, applicationContext),
<i>79</i>&nbsp;
<i>80</i>&nbsp;                new RegisterUserAbcenseCommand(userBookingService, applicationContext),
<i>81</i>&nbsp;                new BookUserCommand(userBookingService, userService, projectService, applicationContext),
<i>82</i>&nbsp;
<i>83</i>&nbsp;                new CreateCompanyCommand(administratorService, applicationContext),
<i>84</i>&nbsp;                new UpdateCompanyCommand(administratorService, applicationContext),
<i>85</i>&nbsp;                new SetGlobalRoleCommand(administratorService, userService, applicationContext),
<i>86</i>&nbsp;
<i>87</i>&nbsp;                documentationCommand,
<i>88</i>&nbsp;                new ExitCommand(applicationContext)
<i>89</i>&nbsp;        );
<i>90</i>&nbsp;
<b class="nc"><i>91</i>&nbsp;        CommandInterpreter commandInterpreter = new CommandInterpreter(commands);</b>
<i>92</i>&nbsp;
<b class="nc"><i>93</i>&nbsp;        documentationCommand.setCommandInterpreter(commandInterpreter);</b>
<i>94</i>&nbsp;
<b class="nc"><i>95</i>&nbsp;        try (Scanner s = new Scanner(System.in, &quot;UTF-8&quot;)) {</b>
<b class="nc"><i>96</i>&nbsp;            System.out.println(&quot;Ready for commands (use the &#39;help&#39; command to view a list of available commands): &quot;);</b>
<i>97</i>&nbsp;
<b class="nc"><i>98</i>&nbsp;            while (!applicationContext.isShutDown()) {</b>
<b class="nc"><i>99</i>&nbsp;                String line = s.nextLine();</b>
<i>100</i>&nbsp;
<i>101</i>&nbsp;                try {
<b class="nc"><i>102</i>&nbsp;                    ParsedCommand parsedCommand = commandInterpreter.parseCommand(line);</b>
<b class="nc"><i>103</i>&nbsp;                    parsedCommand.getCommand().doCommand(parsedCommand);</b>
<b class="nc"><i>104</i>&nbsp;                } catch (Exception e) {</b>
<b class="nc"><i>105</i>&nbsp;                    System.out.println(&quot;An error occurred (&quot; + e.getClass().getSimpleName() + &quot;): &quot; + e.getMessage());</b>
<b class="nc"><i>106</i>&nbsp;                }</b>
<b class="nc"><i>107</i>&nbsp;            }</b>
<b class="nc"><i>108</i>&nbsp;        }</b>
<b class="nc"><i>109</i>&nbsp;    }</b>
<i>110</i>&nbsp;}
</div>
</div>

<div class="footer">
    
    <div style="float:right;">generated on 2019-05-13 13:51</div>
</div>
</body>
</html>
